﻿
Imports System
Imports System.Collections.Generic
Imports System.Threading
Imports System.Threading.Tasks
Imports System.IO
Imports System.Text
Imports System.ComponentModel
Imports System.Drawing.Imaging

Public Class PunktBilderFormular
    Private WithEvents Oberflaeche As New OberflaecheKlasse

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        End
    End Sub

    Private Sub PunktBilderFormular_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'Die Listen für Farben werden gefüllt.
        Programmfarben.Add(Color.Black)
        Programmfarben.Add(Color.Red)
        Programmfarben.Add(Color.White)
        Farben.Add("Schwarz")
        Farben.Add("Rot")
        Farben.Add("Weiss")
        'Jetzt werden Einstellungen vordefiniert.
        ZoomFaktor = 1
        Fensterhintergrundfarbe = Farben.IndexOf("Schwarz")
        Seitenraenderfarbe = Farben.IndexOf("Rot")
        Punktbildhintergrundfarbe = Farben.IndexOf("Weiss")
        ZoomScroll.Value = ZoomFaktor
        Seitenbreite = 210
        Seitenhoehe = 297
        ObererRand = 5
        LinkerRand = 15
        RechterRand = 5
        UntererRand = 5
        PunktBilderFormular_Resize(sender, EventArgs.Empty)
        Oberflaeche.GrafikaufbauStarten()
    End Sub

    Private Sub PunktBilderFormular_Resize(sender As Object, e As EventArgs) Handles Me.Resize
        ZoomScroll.Height = Me.ClientSize.Width / 30
        ZoomScroll.Width = Me.ClientSize.Width - ZoomScroll.Height
        ZoomScroll.Left = 0
        ZoomScroll.Top = 0
        SichtfensterPicture.Left = 0
        SichtfensterPicture.Top = ZoomScroll.Bottom
        SichtfensterPicture.Height = Me.ClientSize.Height - (ZoomScroll.Height * 2)
        SichtfensterPicture.Width = ZoomScroll.Width
        BildflaecheHorizontalScroll.Top = SichtfensterPicture.Bottom
        BildflaecheHorizontalScroll.Left = SichtfensterPicture.Left
        BildflaecheHorizontalScroll.Width = SichtfensterPicture.Width
        BildflaecheHorizontalScroll.Height = ZoomScroll.Height
        BildflaecheVertikalScroll.Top = ZoomScroll.Bottom
        BildflaecheVertikalScroll.Left = SichtfensterPicture.Right
        BildflaecheVertikalScroll.Width = ZoomScroll.Height
        BildflaecheVertikalScroll.Height = SichtfensterPicture.Height
        SichtfensterPuffer = New Bitmap(SichtfensterPicture.ClientSize.Width, SichtfensterPicture.ClientSize.Height)
        SichtfensterObjekt = Graphics.FromImage(SichtfensterPuffer)
        SeiteEinrichten()
    End Sub

    Public Sub SeiteEinrichten()
        If ObererRand > (Seitenhoehe / 2) - 1 Then
            ObererRand = (Seitenhoehe / 2) - 1
        End If
        If UntererRand > (Seitenhoehe / 2) - 1 Then
            UntererRand = (Seitenhoehe / 2) - 1
        End If
        If LinkerRand > (Seitenbreite / 2) - 1 Then
            LinkerRand = (Seitenbreite / 2) - 1
        End If
        If RechterRand > (Seitenbreite / 2) - 1 Then
            RechterRand = (Seitenbreite / 2) - 1
        End If
        If ZoomFaktor * Seitenbreite > SichtfensterPicture.ClientSize.Width Then
            BildflaecheHorizontalScroll.Maximum = Seitenbreite * ZoomFaktor - SichtfensterPicture.ClientSize.Width
        Else
            BildflaecheHorizontalScroll.Maximum = 0
        End If
        If Seitenhoehe * ZoomFaktor > SichtfensterPicture.ClientSize.Height Then
            BildflaecheVertikalScroll.Maximum = Seitenhoehe * ZoomFaktor - SichtfensterPicture.ClientSize.Height
        Else
            BildflaecheVertikalScroll.Maximum = 0
        End If
    End Sub

    Private Sub OberflaecheAnzeigen(Grafik As Bitmap) Handles Oberflaeche.GrafikAufbauen
        SichtfensterPicture.Image = Grafik
    End Sub

    Private Sub SichtfensterPicture_Click(sender As Object, e As EventArgs) Handles SichtfensterPicture.Click

    End Sub

    Private Sub SichtfensterPicture_Resize(sender As Object, e As EventArgs) Handles SichtfensterPicture.Resize
        Oberflaechenbreite = SichtfensterPicture.ClientSize.Width
        Oberflaechenhoehe = SichtfensterPicture.ClientSize.Height
    End Sub

    Private Sub ZoomScroll_Scroll(sender As Object, e As ScrollEventArgs) Handles ZoomScroll.Scroll
        ZoomFaktor = ZoomScroll.Value
    End Sub
End Class
